
////////////////////////////////////////////////////////////////////////////////
// Milestone19_01
//
//-----------------------------------------------------------------------------
// 2019.04.25.()
// 09_HFONT_VS2013_With_LPD3DXSPRITE
//		LPD3DXSPRITE::Draw( g_pHTexture, .... ); Լ ȭ 
//		void Render_Hangul();  Ư DC  ѱ, g_pHTexture 
//
//-----------------------------------------------------------------------------
// File: CreateDevice.cpp
//	...
// Copyright (c) Microsoft Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#include <d3d9.h>
#include <d3dx9.h>

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")   

//timeGetTime() - 1ms  ð 
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")  

/*
#ifndef _UNICODE
#ifdef _DEBUG
#pragma comment(lib, "nafxcwd.lib")
#else
#pragma comment(lib, "nafxcw.lib")
#endif
#else
#ifdef _DEBUG
#pragma comment(lib, "uafxcwd.lib")
#else
#pragma comment(lib, "uafxcw.lib")
#endif
#endif 
*/

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
LPDIRECT3D9         g_pD3D			= NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9	g_pd3dDevice	= NULL; // Our rendering device

HFONT				g_hFont			= NULL;
LPD3DXSPRITE		g_pTextSprite	= NULL;
#define FONT_NAME	L"ü"

//LPD3DXFONT		g_pFont			= NULL;
//#define FONT_FILE	L"2002.ttf"
//#define FONT_NAME	L"2002L"

static float fps = 0.0f;

HDC		g_hDC;
HBITMAP	g_hBmp;
VOID*	g_pBmp = NULL;

LPDIRECT3DTEXTURE9	g_pHTexture = NULL;

#define TEXTURE_WIDTH   128 
#define TEXTURE_HEIGHT  128 


//-----------------------------------------------------------------------------
#define SAFE_RELEASE(p) { if ( (p) ) { (p)->Release(); (p) = 0; } }
#define SAFE_DELETE(a) if( (a) != NULL ) delete (a); (a) = NULL;


//-----------------------------------------------------------------------------
// Name: InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	// Create the D3D object, which is needed to create the D3DDevice.
	if (NULL == (g_pD3D = Direct3DCreate9(D3D_SDK_VERSION)))
		return E_FAIL;

	// Set up the structure used to create the D3DDevice. Most parameters are
	// zeroed out. We set Windowed to TRUE, since we want to do D3D in a
	// window, and then set the SwapEffect to "discard", which is the most
	// efficient method of presenting the back buffer to the display.  And 
	// we request a back buffer format that matches the current desktop display 
	// format.
	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

	// Create the Direct3D device. Here we are using the default adapter (most
	// systems only have one, unless they have multiple graphics hardware cards
	// installed) and requesting the HAL (which is saying we want the hardware
	// device rather than a software one). Software vertex processing is 
	// specified since we know it will work on all cards. On cards that support 
	// hardware vertex processing, though, we would see a big performance gain 
	// by specifying hardware vertex processing.
	if (FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,
		&d3dpp, &g_pd3dDevice)))
	{
		return E_FAIL;
	}

	// Device state would normally be set here
//	AddFontResource(FONT_FILE);
	/*
	D3DXCreateFont(g_pd3dDevice, -20, 0, FW_DONTCARE, 1, FALSE, DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE,
		FONT_NAME, &g_pFont);
*/
	g_hFont = CreateFont(20, 0, 0, 0,
		FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		NONANTIALIASED_QUALITY,
		DEFAULT_PITCH,
		FONT_NAME);

	D3DXCreateSprite(g_pd3dDevice, &g_pTextSprite);

	// LPDIRECT3DTEXTURE9 g_pHTexture   ʱȭ
	g_pd3dDevice->CreateTexture(TEXTURE_WIDTH, TEXTURE_HEIGHT,
		1, 0, D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, &g_pHTexture, NULL);

	g_hDC = CreateCompatibleDC(NULL);

	BITMAPINFO bi;
	ZeroMemory(&bi, sizeof(BITMAPINFO));

	bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth = TEXTURE_WIDTH;
	bi.bmiHeader.biHeight = -TEXTURE_HEIGHT;
	bi.bmiHeader.biPlanes = 1;
	bi.bmiHeader.biBitCount = 32;
	bi.bmiHeader.biCompression = BI_RGB;
	bi.bmiHeader.biSizeImage = 0;
	bi.bmiHeader.biXPelsPerMeter = 100;
	bi.bmiHeader.biYPelsPerMeter = 100;
	bi.bmiHeader.biClrUsed = 0;
	bi.bmiHeader.biClrImportant = 0;

	g_hBmp = CreateDIBSection(g_hDC, &bi, DIB_RGB_COLORS, &g_pBmp, NULL, 0);

	// ޸ Bmp  Ʈ ڸ  κ 
	RECT rc;
	rc.left = 0;
	rc.top = 0;
	rc.right = TEXTURE_WIDTH;
	rc.bottom = TEXTURE_HEIGHT;

	if (g_pHTexture)
	{
		(HBITMAP)::SelectObject(g_hDC, g_hBmp);
		HBRUSH  br = CreateSolidBrush(0x00FF00FF);  //  

		SelectObject(g_hDC, g_hFont);
		FillRect(g_hDC, &rc, br);

		SetBkMode(g_hDC, TRANSPARENT);
		SetTextColor(g_hDC, RGB(0, 255, 0));
		// TextOut(g_hDC, 2, 2, L" Ŀ!", (int)wcslen(L" Ŀ!"));

		DeleteObject(br);
	}
	
	D3DLOCKED_RECT  rect;
	g_pHTexture->LockRect(0, &rect, &rc, 0); //D3DLOCK_DISCARD); 

	UINT* pDst32 = (UINT*)rect.pBits;

	for (int y = 0; y < TEXTURE_HEIGHT; y++)
	{
		for (int x = 0; x < TEXTURE_WIDTH; x++)
		{
			*pDst32 = 0x00FF00FF;
			pDst32++;
		}
	}
	g_pHTexture->UnlockRect(0);

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: Cleanup( HWND hWnd )
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
HRESULT CreateDevice( HWND hWnd )
{
	RECT rc;
	GetWindowRect(hWnd, &rc);

	HDC h_dc = GetDC(NULL);		// 쿡 ׸ ׸ DC
	HBRUSH  br = CreateSolidBrush(RGB(40, 40, 64));  //  
	FillRect(h_dc, &rc, br);
	DeleteObject(br);

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID Cleanup()
{
//	RemoveFontResource(FONT_FILE);
//	SAFE_RELEASE(g_pFont);
	SAFE_RELEASE(g_pTextSprite);
	SAFE_RELEASE(g_pHTexture);
	DeleteObject(g_hBmp);
	DeleteObject(g_hFont);

	if (g_pd3dDevice != NULL)
		g_pd3dDevice->Release();

	if (g_pD3D != NULL)
		g_pD3D->Release();
	
}

//-----------------------------------------------------------------------------
// Name: Render_Hangul()
//-----------------------------------------------------------------------------
void Render_Hangul()
{
	if (g_pHTexture)
	{
//		TextOut(g_hDC, 2, 2, L" Ŀ!", (int)wcslen(L" Ŀ!"));

		// ޸ Bmp  Ʈ ڸ  κ 
		RECT rc;
		rc.left = 0;
		rc.top = 0;
		rc.right = TEXTURE_WIDTH;
		rc.bottom = TEXTURE_HEIGHT;

		// Bmp  Texture ϴ κ 
		D3DLOCKED_RECT  rect;
		g_pHTexture->LockRect(0, &rect, &rc, 0); //D3DLOCK_DISCARD); 

		int i = 0, x = 0, y = 0;
		UINT* pSrc32 = (UINT*)g_pBmp;              // BMP 
		UINT* pDst32 = (UINT*)rect.pBits;         // TEXTURE 

		// bmp ̰ 4  ƴ 
		//  ƾ    ִ. 
		for (y = 0; y < TEXTURE_HEIGHT; y++)
		{
			for (x = 0; x < TEXTURE_WIDTH; x++)
			{
				// 0x00FF00FF  óѴ.  ´. 
				if (*pSrc32 == 0x00FF00FF)
					*pDst32 = 0x00;
				else
					*pDst32 = *pSrc32 | 0xFF000000;

				pDst32++;
				pSrc32++;
			}
		}
		g_pHTexture->UnlockRect(0);
	}
}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID Render()
{
	if (NULL == g_pd3dDevice)
		return;

	Render_Hangul();

	D3DXVECTOR3 vCenter(0.0f, 0.0f, 0.0f);
	D3DXVECTOR3 vPosition(50.0f, 50.0f, 0.0f);

	// Clear the backbuffer to a blue color
	g_pd3dDevice->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_ARGB(0, 0, 0, 255), 1.0f, 0);

	// Begin the scene
	if (SUCCEEDED(g_pd3dDevice->BeginScene()))
	{
//		g_pTextSprite->Begin(D3DXSPRITE_ALPHABLEND | D3DXSPRITE_SORT_TEXTURE);
		g_pTextSprite->Begin(NULL);
/*
		// Rendering of scene objects can happen here
		int y = 10;

		SetRect(&rc, 10, y, 0, 0);
		g_pFont->DrawText(NULL, ("ID3DXFont -   !@#$ 1234 [Normal]"),
			-1, &rc, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f));
		
		SetRect(&rc, 10, y += 30, 0, 0);
		g_pFont->DrawText(g_pTextSprite, ("ID3DXFont -   !@#$ 1234 [Normal Alpha]"),
			-1, &rc, DT_NOCLIP, D3DXCOLOR(1.0f, 1.0f, 1.0f, 0.5f));
*/
		TextOut(g_hDC, 2, 2, L" Ŀ!", (int)wcslen(L" Ŀ!"));

		g_pTextSprite->Draw(g_pHTexture, NULL, &vCenter, &vPosition, D3DCOLOR_XRGB(255, 255, 255));
			
		g_pTextSprite->End();
		
		// End the scene
		g_pd3dDevice->EndScene();
	}

	// Present the backbuffer contents to the display
	g_pd3dDevice->Present(NULL, NULL, NULL, NULL);
}

//-----------------------------------------------------------------------------
// Name: App_Update( HWND hWnd );
//-----------------------------------------------------------------------------
BOOL App_Update(HWND hWnd)
{
	static DWORD frameCount = 0;			// īƮ
	static float timeElapsed = 0.0f;        //帥 ð
	static DWORD lastTime = timeGetTime();  // ð(temp)

	DWORD curTime = timeGetTime();			// ð
	float timeDelta = (curTime - lastTime)*0.001f;        //timeDelta(1 帥 ð) 1ʴ ٲش.

	timeElapsed += timeDelta;

	frameCount++;
	fps = (float)frameCount / timeElapsed;

	if (fps <= 60.0f)
	{
		Render();

		frameCount = 0;
		timeElapsed = 0.0f;
	}

	lastTime = curTime;

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
	case WM_CREATE:
		CreateDevice( hWnd );
		return 0;

	case WM_DESTROY:
		Cleanup();
		PostQuitMessage(0);
		return 0;

	case WM_PAINT:
		// Render();
		ValidateRect(hWnd, NULL);
		return 0;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
			::DestroyWindow(hWnd);
		return 0;

	default:
		App_Update(hWnd);
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR lpCmdLine, INT)
{
	// Register the window class
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
		GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
		L"D3D Tutorial", NULL };
	RegisterClassEx(&wc);

	// Create the application's window
	HWND hWnd = CreateWindow(L"D3D Tutorial", L"09_HFONT_VS2013_With_LPD3DXSPRITE",
		WS_OVERLAPPEDWINDOW, 100, 100, 640, 480,
		GetDesktopWindow(), NULL, wc.hInstance, NULL);

	// Initialize Direct3D
	if (SUCCEEDED(InitD3D(hWnd)))
	{
		// Show the window
		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

		// Enter the message loop
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	UnregisterClass( L"D3D Tutorial", wc.hInstance);

	return 0;
}
