
////////////////////////////////////////////////////////////////////////////////
// Milestone19_01
//
//-----------------------------------------------------------------------------
//	2019.04.23.(ȭ)
//	08_TextOut_VS2013-Using Memory_DC
//		; ޸ DC ڸ ϰ, Filtering Ư ϴ  
//
//-----------------------------------------------------------------------------
// File: CreateDevice.cpp 
//	...
// Copyright (c) Microsoft Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#include <d3d9.h>
#include <d3dx9.h>
#include <stdio.h>

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")   

//timeGetTime() - 1ms  ð 
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")  

// TransparentBlt( ... ); Լ
#pragma comment(lib, "msimg32.lib")
/*
#ifndef _UNICODE
#ifdef _DEBUG
#pragma comment(lib, "nafxcwd.lib")
#else
#pragma comment(lib, "nafxcw.lib")
#endif
#else
#ifdef _DEBUG
#pragma comment(lib, "uafxcwd.lib")
#else
#pragma comment(lib, "uafxcw.lib")
#endif
#endif 
*/

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
#define g_WIDTH		800
#define g_HEIGHT	600

LPDIRECT3D9             g_pD3D = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL; // Our rendering device

#define SAFE_RELEASE(p) { if ( (p) ) { (p)->Release(); (p) = 0; } }
#define SAFE_DELETE(a) if( (a) != NULL ) delete (a); (a) = NULL;

static float fps = 0.0f;


//-----------------------------------------------------------------------------
// Name: InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	// Create the D3D object, which is needed to create the D3DDevice.
	if (NULL == (g_pD3D = Direct3DCreate9(D3D_SDK_VERSION)))
		return E_FAIL;

	// Set up the structure used to create the D3DDevice. Most parameters are
	// zeroed out. We set Windowed to TRUE, since we want to do D3D in a
	// window, and then set the SwapEffect to "discard", which is the most
	// efficient method of presenting the back buffer to the display.  And 
	// we request a back buffer format that matches the current desktop display 
	// format.
	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

	// Create the Direct3D device. Here we are using the default adapter (most
	// systems only have one, unless they have multiple graphics hardware cards
	// installed) and requesting the HAL (which is saying we want the hardware
	// device rather than a software one). Software vertex processing is 
	// specified since we know it will work on all cards. On cards that support 
	// hardware vertex processing, though, we would see a big performance gain 
	// by specifying hardware vertex processing.
	if (FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,
		&d3dpp, &g_pd3dDevice)))
	{
		return E_FAIL;
	}

	return S_OK;
}

//=============================================================================
//-----------------------------------------------------------------------------
HRESULT CreateDevice( HWND hWnd )
{
	RECT rc;
	GetWindowRect(hWnd, &rc);

	HDC h_dc = GetDC(NULL);		// 쿡 ׸ ׸ DC
	HBRUSH  br = CreateSolidBrush(RGB(40, 40, 64));  //  
	FillRect(h_dc, &rc, br);
	DeleteObject(br);

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID Cleanup()
{
	
	if (g_pd3dDevice != NULL)
		SAFE_RELEASE( g_pd3dDevice );

	if (g_pD3D != NULL)
		SAFE_RELEASE( g_pD3D );
	
}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID Render()
{
	if (NULL == g_pd3dDevice)
		return;
}


//=============================================================================
// Name: App_Update( HWND hWnd );
//-----------------------------------------------------------------------------
BOOL App_Update( HWND hWnd )
{
	static DWORD frameCount = 0;			// īƮ
	static float timeElapsed = 0.0f;        //帥 ð
	static DWORD lastTime = timeGetTime();  // ð(temp)

	DWORD curTime = timeGetTime();			// ð
	float timeDelta = (curTime - lastTime)*0.001f;        //timeDelta(1 帥 ð) 1ʴ ٲش.

	timeElapsed += timeDelta;

	frameCount++;
	fps = (float)frameCount / timeElapsed;

	if (fps <= 60.0f)         
	{
		Render();

		frameCount = 0;
		timeElapsed = 0.0f;
	}
	
	lastTime = curTime;

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	HDC hMemDC;
	HBITMAP hBmp, hOldBitmap;
	int bx, by;
	BITMAP bit;

	LPCWSTR str;

	switch (msg)
	{
	case WM_CREATE:
		CreateDevice( hWnd );
		return 0;

	case WM_DESTROY:
		Cleanup();
		PostQuitMessage(0);
		return 0;

	case WM_PAINT:
	{
		hdc = BeginPaint(hWnd, &ps);
		hMemDC = CreateCompatibleDC(hdc);	// ޸ DC 

		// Ʈ Ӽ  ҷ HBITMAP ȯؼ hImage Ѵ
/*
		// ̹ ε
		hBmp = (HBITMAP)LoadImage(NULL, TEXT("190423_image.bmp"),
			IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE | LR_CREATEDIBSECTION);
		//  ܻ
		hBmp = CreateBitmap(256, 256, 1, 32, NULL);

		// Ʈ (Ķ) 
		unsigned int *p = new unsigned int[256*256];	// 256*256*4 ũ ޸ 
		for( int i = 0; i < 256*256; i++)
			*(p+i) = 0xFF0000FF;		// 0xAARRGGBB

		hBmp = CreateBitmap(256, 256, 1, 32, p);

		delete[] p;
*/
		BITMAPINFO bmi;
		unsigned int * pBits;
		ZeroMemory( &bmi, sizeof(BITMAPINFO) );
		bmi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
		bmi.bmiHeader.biWidth			= 256;
		bmi.bmiHeader.biHeight			= -256;
		bmi.bmiHeader.biPlanes			= 1;
		bmi.bmiHeader.biBitCount		= 32;
		bmi.bmiHeader.biCompression		= BI_RGB;;
		bmi.bmiHeader.biSizeImage		= 0;
		bmi.bmiHeader.biXPelsPerMeter	= 100;
		bmi.bmiHeader.biYPelsPerMeter	= 100;
		bmi.bmiHeader.biClrUsed			= 0;
		bmi.bmiHeader.biClrImportant	= 0;

		hBmp = ::CreateDIBSection(hMemDC, &bmi, DIB_RGB_COLORS, (void**)&pBits, NULL, 0);

		// hImage õǱ  ڵ  д
		hOldBitmap = (HBITMAP)SelectObject(hMemDC, hBmp);

		// Ʈ  ˾Ƴ
		GetObject(hBmp, sizeof(BITMAP), &bit);
		bx = bit.bmWidth;
		by = bit.bmHeight;

		// ޸ DC  Ʈ ڸ  κ 
		RECT rc;
		rc.left = 0;
		rc.top = 0;
		rc.right = bx;
		rc.bottom = by;
		
		HBRUSH  br = CreateSolidBrush(0x00FF00FF);  //  (  For filtering )
		FillRect(hMemDC, &rc, br);

		HFONT hFont = CreateFont(30, 0, 0, 0,
			FW_NORMAL, FALSE, FALSE, FALSE,
			ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, NONANTIALIASED_QUALITY, DEFAULT_PITCH, 
			L"ü");

		// 
		SetBkMode(hMemDC, TRANSPARENT);
		SetTextColor(hMemDC, RGB(0, 255, 0));

		SelectObject(hMemDC, hFont);
		str = TEXT("");
		TextOut(hMemDC, 40, 30, str, lstrlen(str));
				
		DeleteObject(hFont);
		DeleteObject(br);

		//-----------------------------------------------------------------------------
		// HBITMAP   Filtering (by 0x00FF00FF)
		//-----------------------------------------------------------------------------
		unsigned int * pSrc32 = (unsigned int *) pBits;
		for (int y = 0; y < by; y++)
		{
			for (int x = 0; x < bx; x++)
			{
				// 0x00FF00FF  óѴ.  ´. 
				if (*pSrc32 == 0x00FF00FF)
					*pSrc32 = 0x00;
				else
					*pSrc32 = *pSrc32 | 0xFF000000;

				pSrc32++;
			}
		}
		//-----------------------------------------------------------------------------

		BitBlt(hdc, 50, 50, bx, by, hMemDC, 0, 0, SRCCOPY);

		// hImage  ϱ  hOldBitmap Ѵ
		SelectObject(hMemDC, hOldBitmap);
		
		DeleteObject(hBmp); //   Ʈ Ѵ
		DeleteDC(hMemDC); // ޸ DC Ѵ

		EndPaint(hWnd, &ps);
		//	ValidateRect(hWnd, NULL);
		return 0;
	}
	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
			::DestroyWindow(hWnd);
		break;

	default:
		App_Update( hWnd );
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR lpCmdLine, INT)
{
	// Register the window class
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
		GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
		L"D3D Tutorial", NULL };
	RegisterClassEx(&wc);

	// Create the application's window
	HWND hWnd = CreateWindow(L"D3D Tutorial", L"08_TextOut_VS2013-Using Memory_DC",
		WS_OVERLAPPEDWINDOW, 100, 100, g_WIDTH, g_HEIGHT,
		GetDesktopWindow(), NULL, wc.hInstance, NULL);

	// Initialize Direct3D
	if (SUCCEEDED(InitD3D(hWnd)))
	{
		// Show the window
		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

		// Enter the message loop
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	UnregisterClass( L"D3D Tutorial", wc.hInstance);

	return 0;
}
