
////////////////////////////////////////////////////////////////////////////////
// Milestone19_01
//
//-----------------------------------------------------------------------------
//	2019.04.19.()
//	07_TextOut_VS2013_ ۸ ;  
//		void drawByDC( HWND hWnd, HDC hdc ); /  void drawByDBuffering( HWND hWnd, HDC hdc );
//		timeGetTime();  ؼ FPS 
//
//-----------------------------------------------------------------------------
// File: CreateDevice.cpp 
//	...
// Copyright (c) Microsoft Corporation. All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

#include <d3d9.h>
#include <d3dx9.h>
#include <stdio.h>

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")   

//timeGetTime() - 1ms  ð 
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")  

// TransparentBlt( ... ); Լ
#pragma comment(lib, "msimg32.lib")
/*
#ifndef _UNICODE
#ifdef _DEBUG
#pragma comment(lib, "nafxcwd.lib")
#else
#pragma comment(lib, "nafxcw.lib")
#endif
#else
#ifdef _DEBUG
#pragma comment(lib, "uafxcwd.lib")
#else
#pragma comment(lib, "uafxcw.lib")
#endif
#endif 
*/

//-----------------------------------------------------------------------------
// Global variables
//-----------------------------------------------------------------------------
LPDIRECT3D9             g_pD3D = NULL; // Used to create the D3DDevice
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL; // Our rendering device

#define SAFE_RELEASE(p) { if ( (p) ) { (p)->Release(); (p) = 0; } }
#define SAFE_DELETE(a) if( (a) != NULL ) delete (a); (a) = NULL;

static float fps = 0.0f;


//-----------------------------------------------------------------------------
// Name: InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------
HRESULT InitD3D(HWND hWnd)
{
	// Create the D3D object, which is needed to create the D3DDevice.
	if (NULL == (g_pD3D = Direct3DCreate9(D3D_SDK_VERSION)))
		return E_FAIL;

	// Set up the structure used to create the D3DDevice. Most parameters are
	// zeroed out. We set Windowed to TRUE, since we want to do D3D in a
	// window, and then set the SwapEffect to "discard", which is the most
	// efficient method of presenting the back buffer to the display.  And 
	// we request a back buffer format that matches the current desktop display 
	// format.
	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory(&d3dpp, sizeof(d3dpp));
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;

	// Create the Direct3D device. Here we are using the default adapter (most
	// systems only have one, unless they have multiple graphics hardware cards
	// installed) and requesting the HAL (which is saying we want the hardware
	// device rather than a software one). Software vertex processing is 
	// specified since we know it will work on all cards. On cards that support 
	// hardware vertex processing, though, we would see a big performance gain 
	// by specifying hardware vertex processing.
	if (FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,
		&d3dpp, &g_pd3dDevice)))
	{
		return E_FAIL;
	}

	return S_OK;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
HRESULT CreateDevice( HWND hWnd )
{
	RECT rc;
	GetWindowRect(hWnd, &rc);

	HDC h_dc = GetDC(NULL);		// 쿡 ׸ ׸ DC
	HBRUSH  br = CreateSolidBrush(RGB(40, 40, 64));  //  
	FillRect(h_dc, &rc, br);
	DeleteObject(br);

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: Cleanup()
// Desc: Releases all previously initialized objects
//-----------------------------------------------------------------------------
VOID Cleanup()
{
	if (g_pd3dDevice != NULL)
		SAFE_RELEASE( g_pd3dDevice );

	if (g_pD3D != NULL)
		SAFE_RELEASE( g_pD3D );
	
}

//-----------------------------------------------------------------------------
// Name: Render()
// Desc: Draws the scene
//-----------------------------------------------------------------------------
VOID Render()
{
	if (NULL == g_pd3dDevice)
		return;
}


//=============================================================================
//-----------------------------------------------------------------------------
void drawByDC(HWND hWnd, HDC hdc)
{
	// ׸ ڵ带 .
	wchar_t lpOut[512];
	swprintf(lpOut, 512, L"FPS ; %0.2f", fps);

	TextOut(hdc, 10, 16, lpOut, wcslen(lpOut));
}

//-----------------------------------------------------------------------------
// Name: DrawOut( HWND hWnd )
//-----------------------------------------------------------------------------
void DrawOut(HWND hWnd)
{
	// ************************************************************************* //
	//  ۸ ó
	// ************************************************************************* //
	RECT windowRect;
	GetClientRect( hWnd, &windowRect );

	// ޸ DC BITMAP 
	HDC hdc = GetDC(hWnd);
	HDC hMemDC;
	HBITMAP bitmap;
	
	// ޸ DC  BitMap  DC  ġ
	hMemDC = CreateCompatibleDC( hdc );
	bitmap = CreateCompatibleBitmap( hdc, windowRect.right, windowRect.bottom );
	
	// ޸ Ʈ DC 
	SelectObject(hMemDC, bitmap);
	
	// ޸ DC 
	HBRUSH  br = CreateSolidBrush(RGB(20, 20, 100)); //  
	FillRect( hMemDC, &windowRect, br );			 // (HBRUSH)COLOR_WINDOWFRAME
	
	drawByDC(hWnd, hMemDC);
	
	// ޸ DC  DC 
	TransparentBlt(hdc, 0, 0, windowRect.right, windowRect.bottom,
		hMemDC, 0, 0, windowRect.right, windowRect.bottom, RGB(255, 0, 255));

	//  ޸ DC  HBITMAP 
	DeleteObject( bitmap );
	DeleteDC( hMemDC );
}

//-----------------------------------------------------------------------------
// Name: App_Update( HWND hWnd );
//-----------------------------------------------------------------------------
BOOL App_Update( HWND hWnd )
{
	static DWORD frameCount = 0;			// īƮ
	static float timeElapsed = 0.0f;        //帥 ð
	static DWORD lastTime = timeGetTime();  // ð(temp)

	DWORD curTime = timeGetTime();			// ð
	float timeDelta = (curTime - lastTime)*0.001f;        //timeDelta(1 帥 ð) 1ʴ ٲش.

	timeElapsed += timeDelta;

	frameCount++;
	fps = (float)frameCount / timeElapsed;

	if (fps <= 60.0f)         
	{
		DrawOut(hWnd);

		frameCount = 0;
		timeElapsed = 0.0f;
	}
	
	lastTime = curTime;

	return S_OK;
}

//-----------------------------------------------------------------------------
// Name: DrawHangul( HWND hWnd )
//-----------------------------------------------------------------------------
#define TEXTURE_WIDTH   128 
#define TEXTURE_HEIGHT  128 

void DrawHangul(HWND hWnd)
{
	HDC hDC = GetDC(hWnd);

	RECT rc;
	rc.left = 0;
	rc.top = 0;
	rc.right = TEXTURE_WIDTH;
	rc.bottom = TEXTURE_HEIGHT;

	HBRUSH  br = CreateSolidBrush(RGB(64, 24, 24));  //  
	FillRect(hDC, &rc, br);

	HFONT hFont = CreateFont(20, 0, 0, 0,
		FW_NORMAL, FALSE, FALSE, FALSE,
		ANSI_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		NONANTIALIASED_QUALITY,
		DEFAULT_PITCH | FF_SWISS,
		L"ü");

	SelectObject(hDC, hFont);
	SetBkMode(hDC, TRANSPARENT);
	SetTextColor(hDC, RGB(0, 255, 255));
	TextOut(hDC, 6, 20,
		L" Ŀ!", (int)wcslen(L" Ŀ!"));

	if (hFont)	DeleteObject(hFont);
	if (br)		DeleteObject(br);

}


//-----------------------------------------------------------------------------
// Name: MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
LRESULT WINAPI MsgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;

	switch (msg)
	{
	case WM_CREATE:
		CreateDevice( hWnd );
		return 0;

	case WM_DESTROY:
		Cleanup();
		PostQuitMessage(0);
		return 0;

	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
/*
		Ellipse(hdc, 10, 10, 200, 90);

		// ؽƮ   Ѵ
		SetTextColor(hdc, RGB(255, 0, 0));
		// ؽƮ   Ķ Ѵ
		SetBkColor(hdc, RGB(255, 255, 0));

		TextOut(hdc, 100, 100, L"Beautiful Korea", 15);
*/
		DrawOut(hWnd);

		EndPaint(hWnd, &ps);

	//	Render();
	//	ValidateRect(hWnd, NULL);
		break;

	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
			::DestroyWindow(hWnd);
		if (wParam == VK_SPACE)
			DrawHangul(hWnd);
		break;

	default:
		App_Update( hWnd );
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

//-----------------------------------------------------------------------------
// Name: WinMain()
// Desc: The application's entry point
//-----------------------------------------------------------------------------
INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR lpCmdLine, INT)
{
	// Register the window class
	WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
		GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
		L"D3D Tutorial", NULL };
	RegisterClassEx(&wc);

	// Create the application's window
	HWND hWnd = CreateWindow( L"D3D Tutorial", L"07_TextOut_VS2013_ ۸",
		WS_OVERLAPPEDWINDOW, 100, 100, 100+640, 100+480,
		GetDesktopWindow(), NULL, wc.hInstance, NULL);

	// Initialize Direct3D
	if (SUCCEEDED(InitD3D(hWnd)))
	{
		// Show the window
		ShowWindow(hWnd, SW_SHOWDEFAULT);
		UpdateWindow(hWnd);

		// Enter the message loop
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	UnregisterClass( L"D3D Tutorial", wc.hInstance);

	return 0;
}
